/**************************************************************
 *
 *  VALTION TEKNILLINEN TUTKIMUSKESKUS (VTT/TEL/TIV)
 *  Otakaari 7 B
 *  02150 Espoo
 *  FINLAND
 *
 *  OTSO Source Code Control System, 12.7.89
 *
 *  Name:	/home/users/otso/official/otso/protocols/3/clns/SCCS/s.clns_serv.hx
 *  Version:	1.3
 *  Time:	91/07/22, 13:30:56
 *
 **************************************************************/

/**********************************************************************
* NAME: clns_serv.hxx
*
* PURPOSE: Connection Less Network Service (CLNS)
*	Service (user and provider) primitive definitions.
**********************************************************************/

/**********************************************************************
Connectionless network service provider interface.
**********************************************************************/

interface class NetSP {
public:
  /* UnitData transfer */
  virtual async n_udtr (
    NSAPaddr source_addr, NSAPaddr dest_addr, slong qos, Frame data
  ) = 0;
};


/**********************************************************************
Connectionless network service user interface.
**********************************************************************/

interface class NetSU {
public:
  /* UnitData transfer */
  virtual async n_udti (
    NSAPaddr source_addr, NSAPaddr dest_addr, slong qos, Frame data
  ) = 0;
};

